public class ArrayExamples {

  public static void main(String[] args) {
    int[] values = new int[6]; // creates an array of integers with 6 values
    values[0] = 311;
    values[1] = 312;
    values[2] = 315;
    values[3] = 318;
    values[4] = 333;
    values[5] = 467;

    // use .length to access number of values
    // access values using []
    for (int i = 0; i < values.length; i++) {
      System.out.println("value at index " + i + " = " + values[i]);
    }

    // enhanced for-loops
    int[] intValues = {311, 312, 315, 318, 333, 467};
    for (int value : intValues) {
      System.out.println("value = " + value);
    }

    String[] stringValues = {"apple", "banana", "pear", "orange"};
    for (String value : stringValues) {
      System.out.println("value = " + value);
    }

    // references
    int[] values0 = {311, 312, 315, 318, 333, 467};
    int[] values1 = values0;
    values1[3] = 321;
    System.out.println(values0[3]);

    // rectangular: all rows have the same size
    int nRows = 10;
    int nCols = 20;
    int[][] matrix = new int[nRows][nCols];
    for (int i = 0; i < nRows; i++) {
      for (int j = 0; j < nCols; j++) {
        matrix[i][j] = 1; // some value
      }
    }

    // jagged: each row has a different size
    char[][] triangle = new char[nRows][];
    System.out.println(triangle[0] == null);

    for (int i = 0; i < triangle.length; i++) {
      triangle[i] = new char[i + 1];
      for (int j = 0; j < triangle[i].length; j++)
        triangle[i][j] = '*';
    }

    for (int i = 0; i < triangle.length; i++) {
      for (int j = 0; j < triangle[i].length; j++)
        System.out.print(triangle[i][j]);
      System.out.print('\n');
    }
  }
}